; nx25.asm: n x 25 + m x 0,1 Hz-es szinuszgenertor, tiszta  n x 25 Hz-cel
; fosc = 6 MHz HS, fmegsz=6 kHz. Jumperes bemenet RB s RC-n. Kimenet RA0.

	list p = 16F1708
	list r = dec
	#include <p16f1708.inc>
	#include <prlx.inc>
	
	__config _CONFIG1, _FOSC_HS& _WDTE_OFF &_PWRTE_ON &_MCLRE_OFF & _CP_OFF &_BOREN_ON & _CLKOUTEN_OFF &_IESO_OFF &_FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_LO & _LPBOR_OFF & _LVP_OFF

	cblock	0x20
	stepl
	steph
	ptrl
	ptr
	flags
	endc
	
	cblock	0x70
	dac_buf
	endc
	
#define	car	flags,7

	org	0
	clrf	pclath
	goto	start
	#include nx25.inc
start
	banksel	lata
	clrf	lata
	clrf	latb
	clrf	latc
	banksel	trisa
	movlw	0x3a
	movwf	trisa
	movlw	0xff
	movwf	trisb
	movwf	trisc
	banksel	ansela
	clrf	ansela
	clrf	anselb
	clrf	anselc
	banksel	osccon
	bcf	option_reg,7
	banksel	wpua
	movlw	0x0e
	movwf	wpua
	movlw	0xf0
	movwf	wpub
	movlw	0xff
	movwf	wpuc
	banksel	borcon
	clrf	borcon
	banksel	wdtcon
	movlw	0x16
	movwf	wdtcon
	banksel	0
	clrf	flags
	movlw	249
	movwf	pr2
	clrf	tmr2
	bsf	t2con,tmr2on
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	ra0pps
	movlw	0x0e
	movwf	ra0pps
	banksel	dac1con0
	movlw	127
	movwf	dac1con1
	movlw	0x90
	movwf	dac1con0
	banksel	pwm3dch
	movlw	125
	movwf	pwm3dch
	clrf	pwm3dcl
	bsf	pwm3con,7
	bsf	intcon,peie
	bsf	intcon,gie
loop	goto	loop

	org	200h
	#include <s240a80.inc>
	end
	
	
	
	
	
	
	
	
