; c33.asm: ngy ctcss frekvencia AD9833-mal, 4 MHz bels rval. 
; Vlaszts:RA4, RA5. SPI: adat RA0, ra RA1, select RA2. PTT RA3.
; Hasznlja a driver33.inc s a prlx.inc fjlt. 

	list p=12F1822
	list r=dec
	#include <p12F1822.inc>
	#include <prlx.inc>
	
	__CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _STVREN_OFF & _BORV_HI & _LVP_OFF
	
; frekvenciaregiszter rtkek
fedtl	equ	1151
fddtl	equ	799
fekmo	equ	1233
fdkmo	equ	1415
	
; az "ellengz" idtartama fzisfordtstl lellsig itt llthat:
; egconst nvelse nveli, cskkentse cskkenti az idt, de az osztk
; nagy rtke miatt ehhez ezres nagysgrend vltoztats szksges.
; a szmts ezzel a konstanssal 3 ciklusnl valamivel rvidebb idt
; eredmnyez, ehhez kpest lehet szmtani az esetleg szksges
; mdostst. az itt szerepl oszts egszek osztsa egsz eredmnnyel!  
egconst	equ	41700		; ez ad kb. 3 peridust.
egedtl	equ	egconst/fedtl	; szak-dunntl
egddtl	equ	egconst/fddtl	; dl-dunntl
egekmo	equ	egconst/fekmo	; szakkelet-magyarorszg 
egdkmo	equ	egconst/fdkmo	; dlkelet-magyarorszg

	cblock	0x20
	index	; pergsmentest szmll
	count	; kt bjtja
	tail	; farok hossza
	endc	
	cblock	0x70
	fblk:4
	fselb
	aux	; egybjtos segdregiszter, ha kell
	flags	; jelzbitek
	cnt	; szoft szmll
	endc

#define	seldd	lata,2
#define	ptt	porta,3
#define	south	porta,5	; csak tjkoztatsul
#define	east	porta,4	; csak tjkoztatsul
#define gie_st	flags,0	; a gie llapota elmenthet

	org	0
	goto	start
	org	4	; csak szoksbl, nincs megszakts
	retfie
	
rly_tbl			; tjtszkrzet tblzat		
	dt high fedtl, low fedtl, high fekmo, low fekmo
	dt high fddtl,  low fddtl,  high fdkmo, low fdkmo
rev_tbl			; fzisfordts idtartama tblzat
	dt	egedtl, egekmo, egddtl, egdkmo	
start
	banksel	lata
	movlw	4
	movwf	lata	; a dds selectje letiltva
	banksel	wpua
	movlw	0x38	; minden bemeneten bels felhz
	movwf	wpua
	banksel	trisa
	bcf	option_reg,7
	movlw	0x38
	movwf	trisa	; ra0, 1, 2 kimenet, a tbbi bemenet
	banksel	ansela	
	clrf	ansela	; nincs analg bemenet
	banksel	osccon
	movlw	0x68
	movwf	osccon	; 4 MHz bels
	banksel	0
; ez az t szubrutin a driver33.inc fjlban tallhat:
	call	spiini
	call	ddsini
	call	fstopd
	call	ph0_0
	call	ph1_pi
; elksztsek
	clrf	fsr1h
	clrf	flags
wait1
	jb	ptt,wait1	
	call	ld_freq	; fblk-t tlti a kapcsolk szerint
	call	ddsprep	; elkszti kivitelre
	call	ddsout	; ki is viszi
	call	startd	; elindtja
	call	mdelay	; pergsmentest
wait2
	jnb	ptt,wait2
	call	chg_ph	; fzisfordts
	call	tdelay	; farokid s debounce
	call	fstopd	; lellts
	goto	wait1	; zrja a fhurkot
; ezek mr szubrutinok	
ld_freq
	movlw	fblk
	movwf	fsr1l
	movlw	0
	movwi	fsr1++
	movwi	fsr1++
	movlw	high rly_tbl
	movwf	fsr0h
	swapf	porta,w
	movwf	aux
	rlf	wreg
	andlw	6
	addlw	low rly_tbl
	movwf	fsr0l
	moviw	fsr0++
	movwi	fsr1++
	moviw	fsr0++
	movwi	fsr1++
	movf	aux,w
	andlw	3
	addlw	rev_tbl
	callw
	movwf	tail
	return

tdelay				; farokhossz
	movf	tail,w
	movwf	index
	clrf	count		
dlp
	djnz	count,dlp	; kb. 771us/index kezdrtk
	djnz	index,dlp
	return
mdelay
	movl	index,40	; debounce
	clrf	count
	goto	dlp
	
	#include <driver33.inc>	
		
	end
	